import java.awt.*;
import javax.media.j3d.*;
import com.sun.j3d.utils.geometry.*;
import javax.vecmath.*;


public class Tren
{
	private BranchGroup raiz;
	public Tren()
	{
		raiz=new BranchGroup();


		Color3f red=new Color3f(Color.red);

		Color3f grey=new Color3f(new Color(128,128,128));
		Color3f yellow=new Color3f(Color.yellow);
		Color3f black=new Color3f(new Color(32,32,32));

		Material matRed=new Material(red,red,red,red, 64.0f);
		Material matGrey=new Material(grey,grey,grey,grey, 64.0f);
		Material matYellow=new Material(yellow,yellow,yellow,yellow, 64.0f);
		Material matBlack=new Material(black,black,black,black, 64.0f);

		Appearance apRed=new Appearance(); apRed.setMaterial(matRed);
		Appearance apGrey=new Appearance(); apGrey.setMaterial(matGrey);
		Appearance apYellow=new Appearance(); apYellow.setMaterial(matYellow);
		Appearance apBlack=new Appearance(); apBlack.setMaterial(matBlack);

//		Cylinder S1=new Cylinder(0.2f,3.0f,apRed);

		Cylinder R1,R2,R3,R4,R5,R6;
		
		R1=new Cylinder(0.5f,3.0f,apRed);
		R2=new Cylinder(0.5f,3.0f,apRed);
		R3=new Cylinder(0.5f,3.0f,apRed);
		R4=new Cylinder(0.5f,3.0f,apRed);
		R5=new Cylinder(0.5f,3.0f,apRed);

		Transform3D T1=new Transform3D();T1.setTranslation(new Vector3f(3.0f,0.0f,0.0f));
		Transform3D T2=new Transform3D();T2.setTranslation(new Vector3f(2.0f,0.0f,0.0f));
		Transform3D T3=new Transform3D();T3.setTranslation(new Vector3f(-1.0f,0.0f,0.0f));
		Transform3D T4=new Transform3D();T4.setTranslation(new Vector3f(-2.0f,0.0f,0.0f));
		Transform3D T5=new Transform3D();T5.setTranslation(new Vector3f(-3.0f,0.0f,0.0f));
		Transform3D T_ruedas=new Transform3D();T_ruedas.setTranslation(new Vector3f(0.0f,0.0f,0.5f));

		TransformGroup TG1=new TransformGroup(T1);
		TransformGroup TG2=new TransformGroup(T2);
		TransformGroup TG3=new TransformGroup(T3);
		TransformGroup TG4=new TransformGroup(T4);
		TransformGroup TG5=new TransformGroup(T5);

		TG1.addChild(R1);
		TG2.addChild(R2);
		TG3.addChild(R3);
		TG4.addChild(R4);
		TG5.addChild(R5);

		TransformGroup TG_ruedas=new TransformGroup(T_ruedas);
		TG_ruedas.addChild(TG1);
		TG_ruedas.addChild(TG2);
		TG_ruedas.addChild(TG3);
		TG_ruedas.addChild(TG4);
		TG_ruedas.addChild(TG5);

		raiz.addChild(TG_ruedas);

		Transform3D T_chassis=new Transform3D();T_chassis.setTranslation(new Vector3f(0.0f,0.0f,0.5f));
		Box chassis=new Box(3.5f+0.1f,1.20f,0.5f,apGrey);
		TransformGroup TG_chassis=new TransformGroup(T_chassis);
		TG_chassis.addChild(chassis);

		raiz.addChild(TG_chassis);


		Transform3D T_bumper=new Transform3D();
		T_bumper.rotX((float)(Math.PI/2));
		T_bumper.setTranslation(new Vector3f(3.5f,0.0f,0.55f));

		Cone bumper=new Cone(1.0f,1.1f,apRed);
		TransformGroup TG_bumper=new TransformGroup(T_bumper);
		TG_bumper.addChild(bumper);

		raiz.addChild(TG_bumper);

		Transform3D T_base=new Transform3D(); T_base.setTranslation(new Vector3f(0.0f,0.0f,1.05f));
		Box base=new Box(3.5f,1.5f,0.1f,apBlack);
		TransformGroup TG_base=new TransformGroup(T_base);
		TG_base.addChild(base);

		raiz.addChild(TG_base);

		Transform3D T_caldera=new Transform3D();
		T_caldera.rotZ((float)(Math.PI/2));
		T_caldera.setTranslation(new Vector3f(1.0f,0.0f,2.0f));

		Cylinder caldera=new Cylinder(1.0f,5.0f,apRed);
		TransformGroup TG_caldera=new TransformGroup(T_caldera);
		TG_caldera.addChild(caldera);

		raiz.addChild(TG_caldera);


		Transform3D T_caldera2=new Transform3D();
		T_caldera2.rotZ((float)(Math.PI/2));
		T_caldera2.setTranslation(new Vector3f(3.1f,0.0f,2.0f));

		Cylinder caldera2=new Cylinder(1.1f,1.0f,apBlack);
		TransformGroup TG_caldera2=new TransformGroup(T_caldera2);
		TG_caldera2.addChild(caldera2);

		raiz.addChild(TG_caldera2);

		Transform3D T_cabina=new Transform3D(); T_cabina.setTranslation(new Vector3f(-2.25f,0.0f,2.25f));
		Box cabina=new Box(1.25f,1.5f,1.25f,apBlack);
		TransformGroup TG_cabina=new TransformGroup(T_cabina);
		TG_cabina.addChild(cabina);

		raiz.addChild(TG_cabina);

		Transform3D T_tapa=new Transform3D(); T_tapa.setTranslation(new Vector3f(3.25f,0.0f,2.0f));
		Sphere tapa=new Sphere(0.75f,apYellow);
		TransformGroup TG_tapa=new TransformGroup(T_tapa);
		TG_tapa.addChild(tapa);

		raiz.addChild(TG_tapa);

		Transform3D T_tapa2=new Transform3D(); T_tapa2.setTranslation(new Vector3f(1.0f,0.0f,3.0f));
		Sphere tapa2=new Sphere(0.25f,apYellow);
		TransformGroup TG_tapa2=new TransformGroup(T_tapa2);
		TG_tapa2.addChild(tapa2);

		raiz.addChild(TG_tapa2);


	}

	public BranchGroup getBranchGroup()
	{
		raiz.compile();
		return raiz;
	}


}
